import  java.io.*;
import  java.util.Scanner;

public class PriorityQueue {

//------------- auxiliary functions -------------------

    public static void printIndexes(int a[]) {
	int i;
	System.out.printf("\n------------------");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",i+1);
	System.out.printf("----\n");
    }

    public static void printArray(int a[]) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",a[i]);
	System.out.printf("]\n");
    }

    public static void printSubArray(int a[], int l, int r) {
	int i;

	System.out.printf("-");
	for(i = l; i <= r; i++)
	    System.out.printf("%2d ",i+1);
	System.out.printf("-\n");
	System.out.printf("[");
	for(i = l; i <= r; i++)
	    System.out.printf("%2d ",a[i]);
	System.out.printf("]\n");
    }

   public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
   } 

    //------------- actual part -------------------
    private static int maxsize = 10000;
    private static int size;
    private static int[] pqueue;


    public static void init() {
	size = 0;
	pqueue = new int[maxsize];
    }

    public static boolean isEmpty() {
	return (size == 0);
    }

    public static void heapify(int a[], int i, int n) {
	int l = 2*(i+1)-1, r = 2*(i+1), m = i;
	if(l <= n && a[l] > a[m]) m = l;
	if(r <= n && a[r] > a[m]) m = r;
	if(i != m) {
	    int t = a[i]; 
            a[i] = a[m];
	    a[m] = t; 
            heapify(a,m,n);
	}
    } 

    public static int extract() {
	int t = pqueue[0]; 
        size--;
	pqueue[0] = pqueue[size];
	heapify (pqueue,0,size);
	return t;
    }

    public static void insert(int x) {
	int i = size+1; 
        //note: here "i" is the index i [1...n], not in [0...n-1]
        size++;
	while(i > 1 && pqueue[i/2-1] < x) {
	    pqueue[i-1] = pqueue[i/2-1];
	    i = i/2;
	}  
	pqueue[i-1] = x;
    }



  public static void main(String args[]) {
      Scanner in = new Scanner(System.in);  
      
      int value;
      char option = 'a';
      String opt = null;
      init();
      do {
	    System.err.println("Options:");
	    System.err.println(" e: check if the list is empty");
	    System.err.println(" i: insert a new element");
	    System.err.println(" d: extract an element");
	    System.err.println(" p: print the content of the queue");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'e': 
	      if (isEmpty())
                 System.out.println("The queue is empty");
              else
                 System.out.println("The queue is not empty");
		break;
	    case 'i': 
	      value = in.nextInt();
              insert(value);
		break;
	    case 'd': 
                if (isEmpty()) 
		  System.out.printf("The queue is empty\n");
		else {
                  value = extract();
		  System.out.printf("Value: %d\n",value);
		}
		break;
	    case 'p': 
		printSubArray(pqueue,0,size-1);
		break;
	    }
	} while (
         option == 'e' || 
         option == 'i' || 
         option == 'd' || 
         option == 'p' 
        );
  }



}
